; blinkenlights.asm
; Copyright (C) 2023  William R. Moore
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; Modified from https://github.com/kloyd/Retro8080/blob/main/funstuff/blinken_pattern.asm
; to run in CP/M and with my own pattern.

	ORG 00H
INIT	LXI H,DATA   ;  HL points to blinken data
	SHLD SAVE_HL

GETD	LHLD SAVE_HL   ;  restore HL
	MOV A,M     ;  get data @ HL
	CPI EOF       ;  End of the data list?
	JZ INIT     ;  Yes, reset HL pointer.
	MOV D,A     ;  No, put in D register for the display pattern.
	INR L       ;  HL++
	SHLD SAVE_HL   ;  Save data

INPDEL	LXI H,0     ;  Init HL to zero before starting the delay loop
	IN 0FFH
	CPI 01H    ;  All Sense switches off finishes the program.
	JZ DONE
	LXI B,4H     ;  Hardcoded timer

BLINK	LDAX D
	LDAX D
	LDAX D
	LDAX D
	DAD B
	JNC BLINK
	JMP GETD
	;  Done with this loop go get the next D

	; Return to CP/M if 00 on sense switches. Some way to drop out.
DONE	HLT
	; Somewhere to save HL, since it will get clobbered by the delay routine.
SAVE_HL	DW 0
	;  Put your pattern list here... this is just jiggy wiggy back forth here.

DATA
	DB 10111010b
	DB 11000011b
	DB 11011111b
	DB 10001000b
	DB 01001000b
	DB 00110000b
	DB 01000110b
	DB 10000010b
	DB 01101010b
	DB 01000000b
	DB 00100111b
	DB 01010111b
	DB 00100000b
	DB 11110010b
	DB 01101111b
	DB 10000011b
	DB 00110011b
	DB 00010101b
	DB 10001100b
	DB 10111011b
	DB 00000000b

	DB EOF


EOF	EQU 042  ; end of data
	END